const CPromise = require('c-promise2');
const axios= require('axios');

// Let's wrap axios get method to the CPromise
function get(url){
    return new CPromise((resolve, reject, {onCancel})=>{
        axios.get(url, {
            cancelToken: new axios.CancelToken(function executor(cancel) {
                onCancel(cancel)
            })
        }).then(resolve, reject);
    });
}

let chain= null;

function makeRequest(url){
    chain && chain.cancel();
    chain= get(url).then((response)=> {
            console.log(`Response ${JSON.stringify(response.data)}`);
        }, function (err) {
            console.warn(`Error: ${err}`);
        }
    );
}

// some endpoint with a delay of 3 seconds for a response
const url= "https://run.mocky.io/v3/753aa609-65ae-4109-8f83-9cfe365290f0?mocky-delay=3s";

makeRequest(url);
//make the same request again, abort the previous
setTimeout(()=> makeRequest(url), 1000);
;
